Peach HTML5 Editor
==================

Peach Editor is a WYSIWYG HTML5 editor for the browser.


Vision
------

Most online HTML editors are built around the "contenteditable" feature of
modern browsers. While this gives developers a lot of features right out of the
box, they must surrender almost complete control over how it works, and thus
we all get stuck using editors that are frustrating and have loads of bugs and
compatibility issues.

Instead of trying to create an ever-expanding set of workarounds for the
quirks, limitations and bugs of different platforms/browsers implementation of
contenteditable, this project aims to create an HTML5 editor that does not use
this feature at all.

This method is much more work, but has the potential to make an editor that is
actually good, since all the code that makes it tick is part of the project,
and its code can be modified.

Jason couldn't find an HTML parser in JavaScript that was at all accurate
according to the HTML5 spec, so he wrote one; see ``parser.js``.

Current work is going into the GUI.


Status
------

The HTML5 parser: complete  component passes the full test suite (1581 tests).

Editor GUI: in early development stages.


Quick Start
-----------

Open ``index.html`` in a browser (no need for a web server)

For further reading, see "Running Under node.js" below.


Technologies
------------

Programming language: JavaScript

HTML5 Parser: Spec compliant, also runs on node.js

Interface: Implemented using the DOM api. No ``contenteditable`` or jquery.


Running Parser with node.js
---------------------------

The parser can run without the browser, try:

	nodejs parser_tests.js


Feedback, Questions, Etc
------------------------

Please communicate directly with Jason Woofenden via his website:
https://jasonwoof.com/contact
